#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{

    FILE *fd;
    char c = '0';
    int count = 0;

    if (argc == 2 || argc == 3)
    {
        if (strcmp(argv[1], "-l") != 0)
        {
            fd = fopen(argv[1], "r");
            if (fd == NULL)
            {
                printf("error: cannot open %s\n", argv[1]);
                return EXIT_FAILURE;
            }
            else
            {
                char temp = c;
                do
                {
                    c = getc(fd);
                    if (c == '.' || c == '?' || c == '!')
                    {
                        if (temp != '.' && temp != '?' && temp != '!')
                            count++;
                    }
                    if (c == EOF && temp != '.' && temp != '?' && temp != '!' && temp != ' ')
                        count++;
                    temp = c;
                } while (c != EOF);
                if (count > 0)
                    printf("%d", count);
            }
        }
        else
        {
            fd = fopen(argv[2], "r");
            if (fd == NULL)
            {
                printf("error: cannot open %s\n", argv[2]);
                return EXIT_FAILURE;
            }
            else
            {
                char temp = c;
                char str[500];
                c = getc(fd);
                do
                {
                    if (temp == '.' || temp == '?' || temp == '!')
                    {
                        if (c == '\n')
                            strcat(str, " ");
                        else
                            strncat(str, &c, 1);
                        if (c != '.' && c != '?' && c != '!')
                        {
                            count++;
                            if (count == 1)
                                printf("[%d] ", count);
                            else
                                printf("\n[%d] ", count);
                            printf("%s", str);
                            memset(str, 0, 255);
                        }
                    }
                    else if (c != '\n')
                    {
                        strncat(str, &c, 1);
                    }
                    else
                    {
                        strcat(str, " ");
                    }
                    temp = c;
                    c = getc(fd);
                    if (c == EOF && (strcmp(str, " ")))
                    {
                        count++;
                        printf("\n[%d] ", count);
                        printf("%s", str);
                        memset(str, 0, 255);
                    }
                } while (c != EOF);
            }
        }
    }
    else
    {
        printf("usage: phrases [-1] file\n");
        return EXIT_FAILURE;
    }
    if (count == 0)
        printf("There are no sentences in file.");
    fclose(fd);
    return EXIT_SUCCESS;
}